<?php

namespace App\Http\Controllers\Api;
use App\Http\Controllers\Api\ApiBaseController;
use App\Http\Requests\CartRequest;
use App\Http\Requests\RemoveCartRequest;
use App\Http\Requests\UpdateCartRequest;
use App\Http\Resources\CartResource;
use App\Http\Resources\cartsCollection;
use App\Http\Resources\ItemsCollection;
use App\Models\Cart;
use App\Repository\CartRepositoryInterface;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class CartController extends ApiBaseController {

    private $cartRepository;

    public function __construct(CartRepositoryInterface $cartRepository)
    {
        $this->cartRepository = $cartRepository;
    }

    public function index() {

        $carts = $this->cartRepository->get_cart(Auth::id());
        return new cartsCollection($carts);

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(CartRequest $request) {


        $inputs=$request->all();
        $inputs['customer_id']=Auth::id();
        $inputs['order_id']=null;

        $cart = $this->cartRepository->check_add_pro($inputs);

        return $this->respondWithSuccessMsg($cart);

    }





    public function update_cart(UpdateCartRequest $request,$cart_id) {



        $this->cartRepository->update($request->all(), $cart_id);


        return $this->respondWithSuccessMsg('the item quantity is updated');
    }

    public function remove_from_cart($id) {



        $check=$this->cartRepository->delete($id);
        if($check){
            return $this->respondWithSuccessMsg('the item is removed from cart');

        }
        else{
            return $this->respondWithSuccessMsg('the item is not exists in the cart');

        }
    }




}
