<?php

namespace App\Http\Controllers\Api;
use App\Http\Controllers\Api\ApiBaseController;
use App\Models\Cart;
use App\Repository\CartRepositoryInterface;
use App\Repository\OrderRepositoryInterface;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;

class OrderController extends ApiBaseController {

    private $orderRepository;

    public function __construct(OrderRepositoryInterface $orderRepository,CartRepositoryInterface  $cartRepository)
    {
        $this->orderRepository = $orderRepository;
        $this->cartRepository=$cartRepository;
    }

    public function save_order(Request  $request){

        $inputs['customer_id']=Auth::id();
        $inputs['total']=$this->get_total(Auth::id());
        $inputs['address']=$request->address;
        $inputs['phone']=$request->phone;

        $customer_credit=Auth::user()->store_credit;

        if($customer_credit>$inputs['total']){

          $order=  $this->orderRepository->create($inputs);
            DB::table('customers')->decrement('store_credit',$inputs['total']);
            Cart::where('customer_id',Auth::id())->where('order_id',null)->update(['order_id'=>$order->id]);
            return $this->respondWithSuccessMsg('the order is paid successfully');


        }
        else{
            return $this->respondWithSuccessMsg('the credit  is not enough to pay the order');

        }


    }

    public function get_total($customer_id){
       return $this->cartRepository->get_cart_total($customer_id);

    }


}
