<?php namespace App\Http\Requests;

use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Http\JsonResponse;

abstract class APIRequest extends FormRequest
{

    protected $message = '';
    protected $description = '';

    public function response(array $errors)
    {
            $description= implode(',',$this->flatten(array_values($errors)));
        $first_description= implode(',',$this->flatten(array_first(array_values($errors))));
            $data = [
                'status' => 422,
                'success' => false,
                'error' => $first_description,
            ];

            return new JsonResponse($data, 422);
        
        
    }
    //local function
    public function flatten(array $array) {
        $return = array();
        array_walk_recursive($array, function($a) use (&$return) { $return[] = $a; });
        return $return;
    }
}
