<?php

namespace App\Repository\Eloquent;
use App\Models\Cart;
use App\Models\Item;
use App\Repository\CartRepositoryInterface;
use Illuminate\Support\Collection;

class CartRepository extends BaseRepository implements CartRepositoryInterface
{

    /**
     * UserRepository constructor.
     *
     * @param Cart $model
     */
    public function __construct(Cart $model)
    {
        parent::__construct($model);
    }

    /**
     * @return Collection
     */
    public function all(): Collection
    {
        return $this->model->all();
    }

    public function check_add_pro($inputs){

     $check_cart=   $this->model->where('customer_id',$inputs['customer_id'])->where('item_id',$inputs['item_id'])->where('order_id',null)->first();
     if ($check_cart!==null) {
         return 'the item is already in cart';

     }
     else{
         $inputs['price']=Item::select('price')->find($inputs['item_id'])->price;
         $this->model->create($inputs);
         return 'item added successfully';

     }
    }

    public function get_cart($customer_id){
        $carts=$this->model->where('customer_id',$customer_id)->where('order_id',null)->get();
        return $carts;
    }

    public function get_cart_total($customer_id){
        $sum=$this->model->where('customer_id',$customer_id)->where('order_id',null)->sum(\DB::raw('quantity * price'));;
        return $sum;
    }


}

